local TT = {
	Event = {},
	data = {
		enabled = true,
		playerID = "",
		dod = 0,
		mis = 0,
		par = 0,
		cri = 0,
		hit = 0,
		blo = 0,
		totalDmg = 0,
		totalAttacks = 0,
		DPA = 0,
		DPS = 0,
		old_dod = 0,
		old_mis = 0,
		old_par = 0,
		old_cri = 0,
		old_hit = 0,
		old_blo = 0,
		old_totalDmg = 0,
		old_totalAttacks = 0,
		old_DPA = 0,
		old_DPS = 0,
		update = true,
	},
	 
}



function TT:On()
	TT.data.enabled = true
	table.insert(Event.Combat.Damage, 		{TT.Event.Damage, 		"TankTables", "Handle Damage"})
	table.insert(Event.Combat.Dodge, 		{TT.Event.Dodge, 		"TankTables", "Handle Dodges"})
	table.insert(Event.Combat.Immune, 		{TT.Event.Immune, 		"TankTables", "Handle Immunes"})
	table.insert(Event.Combat.Miss, 		{TT.Event.Miss, 		"TankTables", "Handle Misses"})
	table.insert(Event.Combat.Parry, 		{TT.Event.Parry, 		"TankTables", "Handle Parries"})
	table.insert(Event.Combat.Resist, 		{TT.Event.Resist, 		"TankTables", "Handle Resists"})
	--table.insert(Event.Combat.Heal, 		{TT.Event.Heal, 		"TankTables", "Handle Heal"})
	--table.insert(Event.Unit.Detail.Combat, 	{TT.Event.Combat, 		"TankTables", "Handle Combats"})
	--table.insert(Event.System.Update.Begin, {TT.Event.Update, 		"TankTables", "Update UI"})
end

function TT:Off()
	TT.data.enabled = false
	TT:UnregisterEvent(Event.Combat.Damage, 		TT.Event.Damage)
	TT:UnregisterEvent(Event.Combat.Dodge, 			TT.Event.Dodge)
	TT:UnregisterEvent(Event.Combat.Immune, 		TT.Event.Immune)
	TT:UnregisterEvent(Event.Combat.Miss, 			TT.Event.Miss)
	TT:UnregisterEvent(Event.Combat.Parry, 			TT.Event.Parry)
	TT:UnregisterEvent(Event.Combat.Resist, 		TT.Event.Resist)
	--TT:UnregisterEvent(Event.Combat.Heal, 			TT.Event.Heal)
	--TT:UnregisterEvent(Event.Unit.Detail.Combat, 	TT.Event.Combat)
	--TT:UnregisterEvent(Event.System.Update.Begin, 	TT.Event.Update)
end


function TT:Toggle()
	TT.data.enabled = not TT.data.enabled
	if TT.data.enabled then
		TT:On()
	else
		TT:Off()
	end
end

function TT:UnregisterEvent(event, func)
	for i, value in ipairs(event) do
		if value[1] == func then
			table.remove(event, i)
		end
	end
end

function TT.Event.LoadEnd(identifier)
	if identifier == "TankTables" then
		TT.data.playerID = Inspect.Unit.Lookup("player")
		
		TT:On()
		
		print("TankTables loaded. /TT")
	end
end


function TT.Event.Damage(info)
if info.caster ~= TT.data.playerID and info.target == TT.data.playerID then
TT.data.totalAttacks = TT.data.totalAttacks +1
	if info.crit then
	TT.data.cri = TT.data.cri +1
	TT.SetText()
	
	elseif info.damageBlocked then
	TT.data.blo = TT.data.blo +1
	TT.SetText()
	
	else
	TT.data.hit = TT.data.hit +1
	TT.SetText()
	end
	
	if info.damage then
	TT.data.totalDmg = TT.data.totalDmg + info.damage
	end
	
	
	end
	
end


function TT.Event.Dodge(info)
	if info.caster ~= TT.data.playerID and info.target == TT.data.playerID then
	
	TT.data.dod = TT.data.dod +1
	TT.data.totalAttacks = TT.data.totalAttacks +1
	TT.SetText()
	
	end
	
end
function TT.Event.Immune(info)
	if info.caster ~= TT.data.playerID and info.target == TT.data.playerID then
	if info.crit then
	print ("Crit-Immune")
	else
	print("Immune")
	
	end
	end
end
function TT.Event.Miss(info)
	if info.caster ~= TT.data.playerID and info.target == TT.data.playerID then
	TT.data.mis = TT.data.mis +1
	TT.data.totalAttacks = TT.data.totalAttacks +1
	TT.SetText()
	
	end
	
end
function TT.Event.Parry(info)
	if info.caster ~= TT.data.playerID and info.target == TT.data.playerID then
	TT.data.par = TT.data.par +1
	TT.data.totalAttacks = TT.data.totalAttacks +1
	TT.SetText()
	
	end
	
end
function TT.Event.Resist(info)
	if info.caster ~= TT.data.playerID and info.target == TT.data.playerID then
	if info.crit then
	print ("Crit-Resist")
	else
	print("Resist")
	
	end
	end
end
function TT.Event.SlashHandler(params)
	if params == "show" then
		TT:On()
	elseif params == "hide" then
		TT:Off()
	else
		TT:Toggle()
	end
end


-- start frames
local main = UI.CreateContext("UI")
local bar = UI.CreateFrame("Frame","Bar",main)
local news = UI.CreateFrame("Text","news",main)
local olds = UI.CreateFrame("Text","olds",main)

bar:SetPoint("TOPLEFT",UI.Native.PortraitTarget,"TOPLEFT",250,20)
	bar:SetBackgroundColor(0,0,0)
	bar:SetWidth(120)
	bar:SetHeight(105)
	bar:SetAlpha(0.4)
	bar:SetLayer(0)
	bar:SetVisible(true)
	
	-- set text colors
	news:SetFontColor(1,1,1,1)
	olds:SetFontColor(1,1,1,1)
	
	
	--set layers and vis
	news:SetLayer(2)
	news:SetVisible(true)
	
	olds:SetLayer(2)
	olds:SetVisible(true)
	
	-- set POS
	
	news:SetPoint("TOPLEFT",UI.Native.PortraitTarget,"TOPLEFT",270,20)
	olds:SetPoint("TOPLEFT",UI.Native.PortraitTarget,"TOPLEFT",355,20)
	
--end frames

function TT.SetText()
	--TT.ClearText()

	if TT.data.totalAttacks == 1000 then
		TT.data.old_dod = TT.data.dod
		TT.data.old_mis =TT.data.mis
		TT.data.old_par=TT.data.par
		TT.data.old_cri=TT.data.cri
		TT.data.old_hit = TT.data.hit
		TT.data.old_blo = TT.data.blo
		TT.data.old_totalDmg = TT.data.totalDmg
		TT.data.old_totalAttacks = TT.data.totalAttacks
		TT.data.dod = 0
		TT.data.mis = 0
		TT.data.par = 0
		TT.data.cri = 0
		TT.data.hit = 0
		TT.data.blo = 0
		TT.data.totalDmg = 0
		TT.data.totalAttacks = 0
		
		bar:SetWidth(255)
		
		olds:SetText("Old Crit - "..tostring(TT.data.old_cri).." :: " .. tostring((TT.data.old_cri/TT.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old Hit - "..tostring(TT.data.old_hit).." :: " .. tostring((TT.data.old_hit/TT.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old Miss - "..tostring(TT.data.old_mis).." :: " .. tostring((TT.data.old_mis/TT.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old Dodge - "..tostring(TT.data.old_dod).." :: " .. tostring((TT.data.old_dod/TT.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old Parry - "..tostring(TT.data.old_par).." :: " .. tostring((TT.data.old_par/TT.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old Block - "..tostring(TT.data.old_blo).." :: " .. tostring((TT.data.old_blo/TT.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old DMG - "..tostring(TT.data.old_totalDmg)..
	
	"\n".."ATK # - "..tostring(TT.data.old_totalAttacks).." :: " .. tostring((math.floor(TT.data.old_totalDmg/TT.data.old_totalAttacks))).."PA")
		end

	
	news:SetText("Crit - "..tostring(TT.data.cri)..
	
	"\n".."Hit - "..tostring(TT.data.hit)..
	
	"\n".."Miss - "..tostring(TT.data.mis)..
	
	"\n".."Dodge - "..tostring(TT.data.dod)..
	
	"\n".."Parry - "..tostring(TT.data.par)..
	
	"\n".."Block - "..tostring(TT.data.blo)..
	
	"\n".."DMG - "..tostring(TT.data.totalDmg)..
	
	"\n".."ATK # - "..tostring(TT.data.totalAttacks))
	
	
	
	
	
end

-- Should clear text frame
function TT.ClearText()
	
	crit:ClearAll()
	
	hit:ClearAll()
	
	miss:ClearAll()
	
	dodge:ClearAll()
	
	parry:ClearAll()
	
	block:ClearAll()
	
	
end

TT.SetText()
table.insert(Event.Addon.Load.End, 				{TT.Event.LoadEnd, 			"TankTables", "Init"})
table.insert(Command.Slash.Register("TT"), 		{TT.Event.SlashHandler, 	"TankTables", "Slash"})